!-----------------------------------------------------------------------
      program database_test
! bring Database_class into scope
      use Student_class
      use Teacher_class
      use Database_class
      implicit none
      integer :: i
      type (Database), target :: cs
      class (Personnel), pointer :: person
      type (Student), pointer :: pstudent 
      type (Teacher), pointer :: pteacher
! Initialize database
      call new(cs)
! Add a student file
      allocate(pstudent)
      call new(pstudent,1,'PAUL','JONES')
      person => pstudent
      call add(cs,person)
! Add a teacher file
      allocate(pteacher)
      call new(pteacher,2,'JOHN','WHITE',1000)
      person => pteacher
      call add(cs,person)
! Locate item in the database with ssn = 1
      person => locate(cs,1)
! Add a physics class
      select type(person)
      class is (Student)
         call addclass(person,'PHYSICS')
      end select
! Locate item in the database with ssn = 2
      person => locate(cs,2)
! Update the salary
      select type(person)
      class is (Teacher)
         call updatesalary(person,2000)
      end select
! Print the database
      call print(cs)
! Delete each data file from database
      do i = 1, get_num_files()
         call remove(cs,i)
      enddo
      end program database_test
