!-----------------------------------------------------------------------
      module Teacher_class
! bring Personnel_class into scope
      use Personnel_class
      implicit none
      private :: Personnel, init_Teacher, print_Teacher
! define Teacher type
      type, extends(Personnel) :: Teacher
         private
         integer :: salary
      contains
         procedure :: print => print_Teacher
      end type Teacher
      interface new
         module procedure init_Teacher
      end interface
      contains
         subroutine init_Teacher(this,s,fn,ln,sal)
! Teacher constructor
         type (Teacher), intent (out) :: this
         integer, intent (in) :: s, sal
         character(len=*), intent (in) :: fn, ln
         call new(this%personnel,s,fn,ln)
         this%salary = sal
         end subroutine init_Teacher
!
         subroutine print_Teacher(this,printssn)
! Print a teacher file
         class (Teacher), intent (in) :: this
         logical, optional, intent (in) :: printssn
         call this%personnel%print(printssn)
         Print *, '-- Salary: ', this%salary
         end subroutine print_Teacher
!
         subroutine updatesalary(this,sal)
         class (Teacher), intent (inout) :: this
         integer, intent (in) :: sal
         this%salary = sal
         end subroutine updatesalary
      end module Teacher_class
